<?php
/**
 * Created by PhpStorm.
 * User: konstantin
 * Date: 1/29/18
 * Time: 3:25 PM
 */

class ActionImport extends CAction
{

    const IMPORT_SCRIPT = '/ntransit/import/import.php';

    private $widget;

    /**
     * Delete partner action
     */
    public function run($widget)
    {
        $this->widget = $widget;

        $widget->controller->pageTitle = $widget->pluginName . ' • Import';

        $importedData = array('hasCurlError' => null, 'curlError' => null, 'formErrors' => null);

        if (Yii::app()->request->isAjaxRequest && (isset($_POST['PartnerFormFull']) &&
                is_array($_POST['PartnerFormFull']) && count($_POST['PartnerFormFull']) || isset($_POST['trigger']))) {

            if (isset($_POST['trigger'])) {
                $this->createTrigger($widget);
            } else {
                $data = array_values($_POST['PartnerFormFull']);

                $partner = new PartnerFormFull();
                $partner->attributes = $data[0];
                $valid = $partner->validate();

                $importedData['formErrors'] = $partner->getErrors();

                /**
                 * Create partner folders
                 */
                $import = null;
                if ($valid) {
                    $import = $this->importPartner($partner, $widget);
                }

                $importedData['valid'] = $valid;
                $importedData['import'] = $import;
                $importedData['partner'] = $partner->name;
                $importedData['debug'] = $partner;

                echo json_encode($importedData);
            }
            Yii::app()->end();

        } else {
            $importedData = $this->getPartnersData();
        }

        /**
         * Add existing partners
         */
        $importedData['existing'] = CHtml::listData(Partner::model()->findAll(), 'id', 'name');

        return $widget->render('standalone', array(
            'breadcrumbs' => $widget->render('breadcrumbs', array('LIST' => NtransitHelper::getBreadcrumbs(array(
                CHtml::link('Home', 'nTransitPlugin'),
                'Import'
            )))),
            'header' => '<i class="fa fa-history" aria-hidden="true"></i> Import',
            'imgPath' => $widget->imgFolder,
            'result' => null,
            'content' => $widget->render('import', array(
                'data' => $importedData,
                'hasCurlError' => $importedData['hasCurlError'],
                'curlError' => $importedData['curlError'],
                'ntransit4Location' => PortalDI::getInstance()->getHost(),
            )),
        ));
    }

    private function createTrigger($widget)
    {
        if (isset($_POST['trigger'])) {
            switch ($_POST['trigger']) {
                case 'trigger_new_file':
                    if (NtransitHelper::createTrigger(NtransitHelper::EVENT_NEW_FILE_LABEL, $widget)) {
                        NtransitHelper::addTriggerEvent(NtransitHelper::EVENT_NEW_FILE,
                            NtransitHelper::EVENT_NEW_FILE_LABEL, $widget);
                        NtransitHelper::addTriggerFolder($widget->volume, NtransitHelper::EVENT_NEW_FILE_LABEL, $widget);
                        echo json_encode(array('error' => false,
                            'result' => NtransitHelper::getStatus("Trigger " . NtransitHelper::EVENT_MOVE_INTO_LABEL
                                . " created")));
                    } else {
                        echo json_encode(array('error' => false,
                            'result' => NtransitHelper::getStatus("Trigger New File already created, continue")));
                    }
                    Yii::app()->end();
                    break;

                case 'trigger_move_into':
                    if (NtransitHelper::createTrigger(NtransitHelper::EVENT_MOVE_INTO_LABEL, $widget)) {
                        NtransitHelper::addTriggerEvent(NtransitHelper::EVENT_MOVE_INTO,
                            NtransitHelper::EVENT_MOVE_INTO_LABEL, $widget);
                        NtransitHelper::addTriggerFolder($widget->volume, NtransitHelper::EVENT_MOVE_INTO_LABEL, $widget);
                        echo json_encode(array('error' => false,
                            'result' => NtransitHelper::getStatus("Trigger " . NtransitHelper::EVENT_MOVE_INTO_LABEL
                                . " created")));
                    } else {
                        echo json_encode(array('error' => false,
                            'result' => NtransitHelper::getStatus("Trigger " . NtransitHelper::EVENT_MOVE_INTO_LABEL
                                . " already created, continue")));
                    }
                    Yii::app()->end();
                    break;


                case 'trigger_download_hi':
                    if (NtransitHelper::createTrigger(NtransitHelper::EVENT_DOWNLOAD_HIRES_LABEL, $widget)) {
                        NtransitHelper::addTriggerEvent(NtransitHelper::EVENT_DOWNLOAD_HIRES,
                            NtransitHelper::EVENT_DOWNLOAD_HIRES_LABEL, $widget);
                        NtransitHelper::addTriggerFolder($widget->volume, NtransitHelper::EVENT_DOWNLOAD_HIRES_LABEL, $widget);
                        echo json_encode(array('error' => false,
                            'result' => NtransitHelper::getStatus("Trigger " . NtransitHelper::EVENT_DOWNLOAD_HIRES_LABEL
                                . " created")));
                    } else {
                        echo json_encode(array('error' => false,
                            'result' => NtransitHelper::getStatus("Trigger " . NtransitHelper::EVENT_DOWNLOAD_HIRES_LABEL
                                . " already created, continue")));
                    }
                    Yii::app()->end();
                    break;

                case 'trigger_download_fpo':
                    if (NtransitHelper::createTrigger(NtransitHelper::EVENT_DOWNLOAD_FPO_LABEL, $widget)) {
                        NtransitHelper::addTriggerEvent(NtransitHelper::EVENT_DOWNLOAD_FPO,
                            NtransitHelper::EVENT_DOWNLOAD_FPO_LABEL, $widget);
                        NtransitHelper::addTriggerFolder($widget->volume, NtransitHelper::EVENT_DOWNLOAD_FPO_LABEL, $widget);
                        echo json_encode(array('error' => false,
                            'result' => NtransitHelper::getStatus("Trigger " . NtransitHelper::EVENT_DOWNLOAD_FPO_LABEL
                                . " created")));
                    } else {
                        echo json_encode(array('error' => false,
                            'result' => NtransitHelper::getStatus("Trigger " . NtransitHelper::EVENT_DOWNLOAD_FPO_LABEL
                                . " already created, continue")));
                    }
                    Yii::app()->end();
                    break;

                case 'trigger_image_order':
                    if (NtransitHelper::createTrigger(NtransitHelper::EVENT_IMAGE_ORDER_LABEL, $widget)) {
                        NtransitHelper::addTriggerEvent(NtransitHelper::EVENT_IMAGE_ORDER,
                            NtransitHelper::EVENT_IMAGE_ORDER_LABEL, $widget);
                        NtransitHelper::addTriggerFolder($widget->volume, NtransitHelper::EVENT_IMAGE_ORDER_LABEL, $widget);
                        echo json_encode(array('error' => false,
                            'result' => NtransitHelper::getStatus("Trigger " . NtransitHelper::EVENT_IMAGE_ORDER_LABEL
                                . " created")));
                    } else {
                        echo json_encode(array('error' => false,
                            'result' => NtransitHelper::getStatus("Trigger " . NtransitHelper::EVENT_IMAGE_ORDER_LABEL .
                                " already created, continue")));
                    }
                    Yii::app()->end();
                    break;

                case 'trigger_image_preview':
                    if (NtransitHelper::createTrigger(NtransitHelper::EVENT_IMAGE_PREVIEW_LABEL, $widget)) {
                        NtransitHelper::addTriggerEvent(NtransitHelper::EVENT_IMAGE_PREVIEW,
                            NtransitHelper::EVENT_IMAGE_PREVIEW_LABEL, $widget);
                        NtransitHelper::addTriggerFolder($widget->volume, NtransitHelper::EVENT_IMAGE_PREVIEW_LABEL, $widget);
                        echo json_encode(array('error' => false,
                            'result' => NtransitHelper::getStatus("Trigger " . NtransitHelper::EVENT_IMAGE_PREVIEW_LABEL
                                . " created")));
                    } else {
                        echo json_encode(array('error' => false,
                            'result' => NtransitHelper::getStatus("Trigger " . NtransitHelper::EVENT_IMAGE_PREVIEW_LABEL .
                                " already created, continue")));
                    }
                    Yii::app()->end();
                    break;

                case 'trigger_date_expired':
                    if (NtransitHelper::createTrigger(NtransitHelper::EVENT_DATE_EXPIRED_LABEL, $widget)) {
                        NtransitHelper::addTriggerEvent(NtransitHelper::EVENT_DATE_EXPIRED,
                            NtransitHelper::EVENT_DATE_EXPIRED_LABEL, $widget);
                        NtransitHelper::addTriggerFolder($widget->volume, NtransitHelper::EVENT_DATE_EXPIRED_LABEL, $widget);
                        echo json_encode(array('error' => false,
                            'result' => NtransitHelper::getStatus("Trigger " . NtransitHelper::EVENT_DATE_EXPIRED_LABEL
                                . " created")));
                    } else {
                        echo json_encode(array('error' => false,
                            'result' => NtransitHelper::getStatus("Trigger " . NtransitHelper::EVENT_DATE_EXPIRED_LABEL .
                                " already created, continue")));
                    }
                    Yii::app()->end();
                    break;
            }
        }

    }

    /**
     * Import partners data
     * @param array $partners
     */
    private function importPartner($partner, $widget)
    {
        $error = false;
        $result = null;

        if ((bool)$partner->import) {

            $created = $this->createPartner($partner);
            if ($created === true) {

                $mainFolder = NtransitHelper::createPartnerFolder($partner->volume, $partner->name, $widget, true);
                $toFolder = NtransitHelper::createPartnerFolder($partner->volume . DIRECTORY_SEPARATOR . $partner->name,
                    $partner->to_partner, $widget, true);
                $fromFolder = NtransitHelper::createPartnerFolder($partner->volume . DIRECTORY_SEPARATOR . $partner->name,
                    $partner->from_partner, $widget, true);


                $error = $mainFolder['error'] && $toFolder['error'] && $fromFolder['error'];

                $result[] = $mainFolder['result'];
                $result[] = $toFolder['result'];
                $result[] = $fromFolder['result'];

                if (!$error) {
                    $result[] = NtransitHelper::getStatus('Successfuly imported');
                }

            } else {
                $error = true;
                $result[] = array('Can\'t create partner ' . $created->getErrors());
            }
        }

        return array('error' => $error, 'message' => $result);
    }

    /**
     * Creates Partner DB records
     * @param PartnerFormFull $partner
     * @return bool|Partner
     */
    private function createPartner($partner)
    {
        /**
         * Overwrite partner settings
         */
        $newPartner = Partner::model()->findByAttributes(array('name' => $partner->name));
        if (!$newPartner) {
            $newPartner = new Partner();
        }

        $newPartner->attributes = $partner->attributes;
        unset($newPartner->config);

        $attributesWithoutConfig = $partner->attributes;
        unset($attributesWithoutConfig->config);

        $newPartner->config = json_encode($attributesWithoutConfig);

        unset($newPartner->id);

        return $newPartner->save() ? true : $newPartner->getErrors();
    }

    /**
     * @return mixed|null|string|string[]
     */
    private function getPartnersData()
    {
        $webnativeHost = PortalDI::getInstance()->getHost();
        $username = Yii::app()->user->username;
        $password = Encryption::getInstance()->decrypt(Yii::app()->user->wn_password);

        /**
         * Initialize cURL
         */
        $ch = curl_init();

        /**
         * set up additional cURL params
         */
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
        curl_setopt($ch, CURLOPT_URL, $webnativeHost . self::IMPORT_SCRIPT);
        curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
        curl_setopt($ch, CURLOPT_TIMEOUT, 30);
        curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, 30);
        curl_setopt($ch, CURLOPT_BINARYTRANSFER, true);
        curl_setopt($ch, CURLOPT_HTTPHEADER,
            array(
                "Authorization: Basic " . base64_encode($username . ":" . $password),
                "Compression: deflate",
                "User-Agent: XWNP"
            ));

        curl_setopt($ch, CURLOPT_HEADER, 0);

        /**
         * execute cURL and get output
         */
        $output = curl_exec($ch);

        $curl_info = curl_getinfo($ch);

        $curlError = null;
        if ($hasCurlError = curl_errno($ch)) {
            $curlError = 'CURL error ' . curl_errno($ch) . ': ' . curl_error($ch) . ' ' . print_r($curl_info, true);
            Yii::log($curlError, 'ERROR', get_class($this));
        }

        curl_close($ch);

        try {
            $result = json_decode($output, true);

            /**
             * if output is illegal json, this may be because of weird symbols,
             * so we try to convert thos symbols and decode json again
             */
            if (!$result) {

                $output = mb_convert_encoding(
                    $output,
                    "HTML-ENTITIES",
                    "UTF-8"
                );
                $result = json_decode($output, true);

                if (!$result) {
                    $result = $output;
                }
            }

        } catch (Exception $exception) {
            $result = $output;
        }

        $result['hasCurlError'] = $hasCurlError;
        $result['curlError'] = $curlError;

        $partnersArray = array();
        if (isset($result['data']) && is_array($result['data']) && count($result['data'])) {

            foreach ($result['data'] as $name => $fields) {
                $partner = new PartnerFormFull();
                $partner->name = $name;
                $partner->to_partner = $fields['out_folder'];
                $partner->from_partner = $fields['in_folder'];
                $partner->volume = $fields['volume'];

                $partner->deliveryType = $fields['is_collecting_files'];
                $partner->folderLifespan = $fields['dir_life_span'];
                $partner->hires = $fields['show_file_link_highrez'];
                $partner->preview = $fields['show_file_link_preview'];
                $partner->stream = $fields['show_file_link_stream'];
                $partner->partnerHasSite = false; // field does not exist in nTransit4
                $partner->downloadRecipients = $fields['download_mail_recipients'];
                $partner->downloadHiresStream = $fields['download_mail_notify_highrez_and_stream'];
                $partner->downloadPreview = $fields['download_mail_notify_preview'];

                $partner->sentFrom = $fields['out_mail_reply_to'];
                $partner->sentName = $fields['out_mail_main_contact_name'];
                $partner->sentRecipients = $fields['out_mail_recipient_emails'];
                $partner->sentCCRecipients = $fields['out_mail_cc_emails'];
                $partner->sentBCCRecipients = $fields['out_mail_bcc_emails'];
                $partner->sentSubject = $fields['out_mail_subject'];
                $partner->sentMessage = $fields['out_mail_message'];

                $partner->receivedFrom = $fields['in_mail_reply_to'];
                $partner->receivedName = $fields['in_mail_main_contact_name'];
                $partner->receivedRecipients = $fields['in_mail_recipient_emails'];
                $partner->receivedCCRecipients = $fields['in_mail_cc_emails'];
                $partner->receivedBCCRecipients = $fields['in_mail_bcc_emails'];
                $partner->receivedSubject = $fields['in_mail_subject'];
                $partner->receivedMessage = $fields['in_mail_message'];

                $partnersArray[] = $partner;
            }
        }

        $result['partners'] = $partnersArray;

        return $result;
    }

}